/**
; * @file asm.s
; * Provides assembly support functions for C.
; */

    .area text(rom, rel)

;-------------------------------------------------------------------------------
; long getBSS(void);
; Gets bss start for initializing malloc heap - move to common code.
; See header for more details.
;-------------------------------------------------------------------------------
_getBss::
        @FLOAD
		.long  text_end   
        mov R0,TEMP0
@FRET
    
;-------------------------------------------------------------------------------
; int cognewNative(long* R0, long* R1);
; See header for more details.
;-------------------------------------------------------------------------------
_cognewNative::
        shr R0,#2   ; zero 2 LSB
        shl R0,#4   ; get function address into the right place
        shr R1,#2   ; get par into the the right place ... zeros 2 LSB
        shl R1,#18
        or R0, #8   ; get a new COG
        or R0,R1
        COGINIT R0 WR WC WZ
@FRET

;-------------------------------------------------------------------------------
; void memcpy(char* R0, char* R1, int R2);
; Copy a block of memory using LMM kernel call.
; Missing from library.
; @param R0 is pointer to destination to copy
; @param R1 is pointer to source of copy
; @param R2 is number of words to copy
;-------------------------------------------------------------------------------
__memcpy::
        @FBYTECOPY
@FRET

;-------------------------------------------------------------------------------
; void bytefill(char* R0, char R1, int R2);
; See header for more details.
;-------------------------------------------------------------------------------
_bytefill::
        mov TEMP0,R1
        wrbyte TEMP0,R0
        add R0,#2
        add R1,#2
        sub R2,#2       WZ
IF_NZ   sub PC,#5*4
@FRET

;-------------------------------------------------------------------------------
; void bytemove(char* R0, char R1, int R2);
; See header for more details.
;-------------------------------------------------------------------------------
_bytemove::
        @FBYTECOPY
@FRET

;-------------------------------------------------------------------------------
; void wordfill(short* R0, short R1, int R2);
; See header for more details.
;-------------------------------------------------------------------------------
_wordfill::
        shl R2,#1
        mov TEMP0,R1
        wrword TEMP0,R0
        nop
        add R0,#2
        add R1,#2
        sub R2,#2       WZ
IF_NZ   sub PC,#6*4
@FRET

;-------------------------------------------------------------------------------
; void wordmove(short* R0, short R1, int R2);
; See header for more details.
;-------------------------------------------------------------------------------
_wordmove::
;       @FWORDCOPY  ... word copy only does half of r2
        shl R2,#1
        rdword TEMP0,R1
        wrword TEMP0,R0
        add R0,#2
        add R1,#2
        sub R2,#2       WZ
IF_NZ   sub PC,#6*4
@FRET

;-------------------------------------------------------------------------------
; void longfill(long* R0, long R1, int R2);
; See header for more details.
;-------------------------------------------------------------------------------
_longfill::
        shl R2,#2
        mov TEMP0,R1
        wrlong TEMP0,R0
        add R0,#2
        add R1,#2
        sub R2,#2       WZ
IF_NZ   sub PC,#5*4
@FRET

;-------------------------------------------------------------------------------
; void longmove(long* R0, long R1, int R2);
; See header for more details.
;-------------------------------------------------------------------------------
_longmove::
;       @FLONGCOPY  ... long copy only does fourth of r2
        shl R2,#2
        rdlong TEMP0,R1
        wrlong TEMP0,R0
        add R0,#2
        add R1,#2
        sub R2,#2       WZ
IF_NZ   sub PC,#6*4
@FRET

;-------------------------------------------------------------------------------
; int mod(int R0, int R1);
; See header for more details.
;-------------------------------------------------------------------------------
_mod::
        @FDIV32U
        mov     R0, R1
@FRET
